<?php
  include("include/head.php");
  include("include/leds.php");
?>
</head>

<body>
<div class="wrap">
<h1><?php echo $settings['Options']['DeviceTitle'] ?></h1>

<?php
 if(isset($_REQUEST['submit'])){
  if(isset($_POST['logDumpEnable'])){
   $settings['Options']['logDumpEnable']="Yes";
   touch ("/var/www/html/state/hourlyLogDump");
  }else{
   $settings['Options']['logDumpEnable']="No";
   unlink("/var/www/html/state/hourlyLogDump");
  }
  if(isset($_POST['midnightRestart'])){
      $settings['Options']['midnightRestart']="Yes";
      touch ("/var/www/html/state/midnightRestart");
  }else{
      $settings['Options']['midnightRestart']="No";
      unlink("/var/www/html/state/midnightRestart");
  }
  if(isset($_POST['SSHenable'])&&$settings['Options']['SSHenable']=="No"){
   touch ("/var/www/html/state/cylon");
   $settings['Options']['SSHenable']="Yes";
   exec("sudo systemctl enable ssh");
   exec("sudo systemctl start ssh");
  }elseif(!isset($_POST['SSHenable'])&&$settings['Options']['SSHenable']=="Yes"){
   touch ("/var/www/html/state/cylon");
   $settings['Options']['SSHenable']="No";
   exec("sudo systemctl disable ssh");
   exec("sudo systemctl stop ssh");
  }
  file_put_contents("config/settings.dat", json_encode($settings));
  exec("sudo sync");
 }
 if(isset($_REQUEST['defaults'])){
     // return to defaults handle files
     touch ("/var/www/html/state/cylon");
     unlink("config/settings.dat");
     $settings = parse_ini_file("config/settings.ini", true);
     file_put_contents("config/settings.dat", json_encode($settings));
     copy("/var/www/html/".$settings['State']['Default'], "/var/www/html/".$settings['State']['FileName']);
     exec("sudo sync");
     exec("sudo systemctl disable ssh");
     exec("sudo systemctl stop ssh");
     touch ("/var/www/html/state/restart");    // signal restart network
 }
 if(isset($_REQUEST['halt'])){
     // flash all the LEDs 6 times to indicate shutdown
     flashLeds(6);
     exec("sudo sync");
     exec('sudo shutdown -h now'); // halt the device
 }
 if(isset($_REQUEST['reboot'])){
     // flash all the LEDs 7 times to indicate shutdown
     flashLeds(7);
     exec("sudo sync");
     exec('sudo shutdown -r now'); // reboot the device
 }
 if(isset($_REQUEST['phoneHome'])){
     $localIP = GetIpAddress();
     exec('sudo wget "https://www.katoombasound.com/tools/SpeakerSwitchPhoneHome.php?model=SPKR7&IP='.$localIP.'" --no-check-certificate -O /dev/null');
     exec("sudo sync");
     // flash all the LEDs once to indicate phoning home
     flashLeds(1);
 }
 if(isset($_REQUEST['flashLEDS'])){
     // flash all the LEDs ten times to provide visual indicatation of which unit this is
     flashLeds(10);
 }
 if(isset($_REQUEST['CylonOn'])){
     // turn Cylon LEDs on
     touch ("/var/www/html/state/cylon");
 }
 if(isset($_REQUEST['CylonOff'])){
     // turn Cylon LEDs off
     unlink("/var/www/html/state/cylon");
 }
 if(isset($_REQUEST['RestartSpkrServices'])){
     exec('sudo systemctl daemon-reload');
     exec('sudo systemctl restart spkrIo.service');
     exec('sudo systemctl restart spkrWatchdog.service');
     flashLeds(8);
 }
 if(isset($_REQUEST['RestartApache'])){
     exec('sudo systemctl restart apache2.service');
     flashLeds(8);
 }
 if(isset($_REQUEST['RestartChrony'])){
     exec('sudo systemctl restart chrony.service');
     flashLeds(8);
 }
 include("include/menu.php");
?>
<div id="pge">
<h2>Advanced - Settings</h2>
<form id="form" name="form" method="post">
<div class="group">

 <div class="left">Enable SSH:</div><div class="right"><input type="checkbox" name="SSHenable" <?php if($settings['Options']['SSHenable']=="Yes") echo "checked"; ?> ></div><div class="right">Tick this box to enable SSH access to the speaker switch unit.  Do NOT enable SSH unless you understand the security implications.</div><br><br>
 <div class="left">Hourly Log Dump:</div><div class="right"><input type="checkbox" name="logDumpEnable" <?php if($settings['Options']['logDumpEnable']=="Yes") echo "checked"; ?> ></div><div class="right">Tick this box to enable log dumps each hour.</div><br><br>
 <div class="left">Midnight Device Restart:</div><div class="right"><input type="checkbox" name="midnightRestart" <?php if($settings['Options']['midnightRestart']=="Yes") echo "checked"; ?> ></div><div class="right">Tick this box to enable automatic speaker switch device restart every midnight.</div><br><br>
 <hr>
 <div class="left">Processor:</div><div class="right"><select class="select" name="Processor">
  <option value="RaspberryPi" <?php if($settings['Options']['Processor']=="Raspberry Pi") echo "selected"; ?> >Raspberry Pi</option>
  <option value="BananaPi" <?php if($settings['Options']['Processor']=="Banana Pi") echo "selected"; ?> >Banana Pi</option>
  <option value="OrangePi" <?php if($settings['Options']['Processor']=="Orange Pi") echo "selected"; ?> >Orange Pi</option>
  <option value="OtherPi" <?php if($settings['Options']['Processor']=="Other") echo "selected"; ?> >Other Pi</option>
 </select></div><div class="right">
 Do NOT change the processor unless instructed to do so by technical support!</div><hr>

 <div id="last" class="group">
  <input class="submit" type="submit" name="submit" onclick="return confirmSave()" value="Apply Changes">
 </div>
 <div id="last" class="group">
  <div class="left" style="font-size:15px;">Actions</div><hr>
  <input class="submit" type="submit" name="defaults" onclick="return statusConfirmDefault()" value="Factory Settings">
  <input class="submit" type="submit" name="halt" onclick="return statusConfirmHalt()" value="Halt Device">
  <input class="submit" type="submit" name="reboot" onclick="return statusConfirmReboot()" value="Reboot Device">
  <input class="submit" type="submit" name="phoneHome" value="Phone Home">
  <input class="submit" type="submit" name="flashLEDS" value="Flash LEDS 10x">
<?php
  if(file_exists("/var/www/html/state/cylon")) echo '<input style="background-color: crimson;" class="submit" type="submit" name="CylonOff" value="Cylon LEDs Off">';
  else echo '<input class="submit" type="submit" name="CylonOn" value="Cylon LEDs On">';
?>
  <input class="submit" type="submit" name="RestartSpkrServices"  onclick="return statusConfirmRestartLEDService()" value="Restart Spkr Services">
  <input class="submit" type="submit" name="RestartApache"  onclick="return confirm('Restarting the apache web service will reset your web page. Are you sure you want to restart apache?')" value="Restart Apache">
  <input class="submit" type="submit" name="RestartChrony"  onclick="return confirm('Are you sure you want to restart the chrony time service?')" value="Restart Chrony">
  </div>

</div>

<h2>Advanced - Status</h2>

<div class="group">
 <div id="last" class="group">
  <div class="left" style="font-size:15px;">WiFi Status</div><hr>
  <p style="color:white;text-align:left;font-family:courier;">
  <?php echo GetWiFiAll(); ?>
  </p>
 </div>
</div>

<div class="group">
 <div id="last" class="group">
  <div class="left" style="font-size:15px;">OS Version</div><hr>
  <p style="color:white;text-align:left;font-family:courier;">
  <?php echo GetOsVersion(); ?>
  </p>
 </div>
</div>

</form> 
</div>
</div>
</body>
</html>
