<?php
// functions for setting up WiFi
function setup_network($SSID="katoombasound", $SSIDPASS="thethreesisters", $DHCP="static", $IP="192.168.4.123", $MASK="255.255.255.0", $GW="192.169.4.123", $DNS="192.168.4.123"){
 if($SSID=="katoombasound"){
  exec("sudo ifconfig wlan0 down");
  // configure dhcpcd.conf
  $dhcpcd=file('/var/www/html/scripts/dhcpcd.conf');
  $dhcpcd[]="interface wlan0\n";
  $dhcpcd[]="static ip_address=192.168.4.123/24\n";
  $dhcpcd[]="nohook wpa_supplicant";
  file_put_contents('/var/www/html/scripts/dhcpcd.conf.new',$dhcpcd);
  exec("sudo cp /var/www/html/scripts/dhcpcd.conf.new /etc/dhcpcd.conf");
  // configure dnsmasq
  exec("sudo cp /var/www/html/scripts/dnsmasq.conf /etc/dnsmasq.conf");
  // configure wpa_supplicant
  $wpa[]="ctrl_interface=DIR=/var/run/wpa_supplicant\n";
  $wpa[]="update_config=1\ncountry=US\n\n";
//  $wpa[]="network={\n";
//  $wpa[]="  scan_ssid=1\n";
//  $wpa[]='  ssid="katoombasound"'."\n";
//  $wpa[]='  psk="thethreesisters"'."\n";
//  $wpa[]="}";
  file_put_contents('/var/www/html/scripts/wpa_supplicant.conf.new',$wpa);
  exec("sudo cp /var/www/html/scripts/wpa_supplicant.conf.new /etc/wpa_supplicant/wpa_supplicant.conf");
  // configure hostapd
  exec("sudo cp /var/www/html/scripts/hostapd.conf /etc/hostapd/hostapd.conf");
  //restart and bring up wlan0 network
  exec("sudo systemctl daemon-reload");
  exec("sudo systemctl restart dhcpcd");
  exec("sudo systemctl restart wpa_supplicant");
  exec("sudo systemctl restart dnsmasq");
  exec("sudo systemctl restart hostapd");
  exec("sudo ifconfig wlan0 up");
 }else{
  exec("sudo ifconfig wlan0 down");
  if($DHCP=="dhcp"){
   // using DHCP
   $dhcpcd=file('/var/www/html/scripts/dhcpcd.conf');
   file_put_contents('/var/www/html/scripts/dhcpcd.conf.new',$dhcpcd);
   exec("sudo cp /var/www/html/scripts/dhcpcd.conf.new /etc/dhcpcd.conf");
  }else{
   // using statics
   $dhcpcd[]="require dhcp_server_identifier\n";
   $dhcpcd[]="slaac private\n";
   $dhcpcd[]="nohook lookup-hostname\n\n";
   $dhcpcd[]="interface wlan0\n";
   $dhcpcd[]="static ip_address=".$IP."/".mask2cidr($MASK)."\n";
   $dhcpcd[]="static routers=".$GW."\n";
   file_put_contents('/var/www/html/scripts/dhcpcd.conf.new',implode($dhcpcd));
   exec("sudo cp /var/www/html/scripts/dhcpcd.conf.new /etc/dhcpcd.conf");
  }
  // now do what is common for both static and DHCP
  $resolver[]="# Managed by SpeakerSwitch\n";
  if(strlen($DNS)>0){
   $resolver[]="nameserver ".$DNS."\n";
  }
  file_put_contents('/var/www/html/scripts/resolv.conf',implode($resolver));
  exec("sudo cp /var/www/html/scripts/resolv.conf /etc/resolvconf/resolv.conf.d/head");
  exec("sudo /usr/sbin/resolvconf --enable-updates");
  exec("sudo /usr/sbin/resolvconf -u");

  $wpa[]="ctrl_interface=DIR=/var/run/wpa_supplicant\n";
  $wpa[]="update_config=1\n";
  $wpa[]="country=US\n\n";
  $wpa[]="network={\n";
  $wpa[]="  scan_ssid=1\n";
  $wpa[]='  ssid="'.$SSID.'"'."\n";
  if(strlen($SSIDPASS)==0) $wpa[]='  key_mgmt="NONE"'."\n";
  else $wpa[]='  psk="'.$SSIDPASS.'"'."\n";
//  $setup[]="  key_mgmt=WPA-PSK\n";
  $wpa[]="}\n";
  file_put_contents('/var/www/html/scripts/wpa_supplicant.conf.new',implode($wpa));
  exec("sudo cp /var/www/html/scripts/wpa_supplicant.conf.new /etc/wpa_supplicant/wpa_supplicant.conf");
//  exec("sudo systemctl unmask hostapd");
  exec("sudo systemctl stop hostapd");
//  exec("sudo systemctl disable hostapd");
  exec("sudo rm /etc/dnsmasq.conf");
  exec("sudo touch /etc/dnsmasq.conf");
  exec("sudo systemctl daemon-reload");
  exec("sudo systemctl restart dhcpcd");
//  exec("sudo systemctl enable wpa_supplicant.service");
  exec("sudo systemctl restart wpa_supplicant.service");
  exec("sudo systemctl restart dnsmasq");
  exec("sudo wpa_cli -i wlan0 reconfigure");
  exec("sudo ifconfig wlan0 up");
 }
 if(file_exists("/var/www/html/state/cylon")) unlink("/var/www/html/state/cylon");
}

function GetVersion(){
 if(is_file('version.txt')){
  $contents = file_get_contents('version.txt');
  $contents = trim($contents, "\n\r");
  return $contents;
 }else{
  return "Unknown";
 }
}

function IsWiFiConnected(){
    exec( "sudo ifconfig wlan0 | grep inet | awk -F 'inet' '{print \$NF; exit}' | awk '{print $1}'", $output, $returned );
    if(filter_var(trim(implode($output)), FILTER_VALIDATE_IP) !== false) return TRUE;
    else return FALSE;
}

function GetWiFiStatus(){
 exec("iw dev wlan0 info 2>&1", $output, $returned);
 if(strpos($output[4],"ssid katoombasound")!==FALSE) return 'Is Access Point: "katoombasound"';
 if(strpos($output[4],"type managed")!==FALSE) return '** Not Associated **';
 unset($output);
 exec("iwconfig wlan0 | grep ESSID | awk '{print $4}'",$output,$returned);
 $result = explode(":",$output[0]);
 if(strpos($result[0],"ESSID")!==FALSE) return ("Associated with: ".$result[1]);
 else return ("** ERROR **");
}

function GetWiFiAll(){
    exec("iwconfig wlan0",$output,$returned);
    return implode("<br>", $output);
    //    return "<ul><li>" . implode("</li><li>", $output) . "</li></ul>";
}

function getPhyStatus($phy='eth0'){
    return "Up";
}

function GetIpAddress($phy='wlan0'){
  exec( "sudo ifconfig $phy | grep inet | awk -F 'inet' '{print \$NF; exit}' | awk '{print $1}'", $output, $returned );
  if(strlen(trim(implode($output)))>0) return trim(implode($output));
  else return ("** Not Assigned **");
}

function GetMacAddress($phy='wlan0'){
    exec( "sudo ifconfig $phy | grep ether | awk -F 'ether' '{print \$NF; exit}' | awk '{print $1}'", $output, $returned );
    return trim(implode($output));
//    if(strlen(trim(implode($output)>0))) return trim(implode($output));
//    else return ("** Not Assigned **");
}

function mask2cidr($mask){
  $long = ip2long($mask);
  $base = ip2long('255.255.255.255');
  return 32-log(($long ^ $base)+1,2);
    
  /* xor-ing will give you the inverse mask,
   log base 2 of that +1 will return the number
   of bits that are off in the mask and subtracting
   from 32 gets you the cidr notation */
}

function GetModelInfo(){
  exec( "cat /proc/device-tree/model", $output, $returned );
  if(strpos(implode($output),"Raspberry")!==FALSE){
   return implode($output);
  }elseif(strpos(implode($output),"Banana")!==FALSE){
   return "Banana Pi - ".implode($output);
  }elseif(strpos(implode($output),"Orange")!==FALSE){
   return "Orange Pi - ".implode($output);
  }else{
   return "Other";
  }
}

function GetUpTime(){
    exec( "uptime -p", $output, $returned );
    return $output[0];
}

function GetCPUTemp($CPU){
    if($CPU=="Raspberry Pi"){
        // raspberrypi has one sensor
        exec( "cat /sys/class/thermal/thermal_zone0/temp", $output, $returned );
        return $output[0]/1000;
    }elseif($CPU=="Banana Pi"){
        // bananapi has one sensor
        exec( "cat /etc/armbianmonitor/datasources/soctemp", $output, $returned );
        return $output[0]/1000;
    }elseif($CPU=="Orange Pi"){
        // orangepi has two sensors
        exec( "cat /sys/devices/virtual/thermal/thermal_zone0/temp", $output0, $returned );
        exec( "cat /sys/devices/virtual/thermal/thermal_zone1/temp", $output1, $returned );
        return ($output0[0]+$output0[0])/2000;
    }else{
        return "Not Available";
    }
}

function GetServiceStatus($serviceName="spkrIo.service"){
	exec( "sudo systemctl status ".$serviceName." --no-pager", $output, $returned );
	if(strpos($output[2],"running")!==FALSE){
		return "Running";
	}elseif(strpos($output[2],"inactive")!==FALSE){
		return "Stopped";
	}else{
		return "Unknown";
	}
}

function GetOsVersion(){
    exec("uname -a",$output,$returned);
    return implode("<br>", $output);
}

?>
