<?php
echo date("Y-m-d H:i:s").": Starting spkrIo service.\n";

include("/var/www/html/include/speakers.php");
include("/var/www/html/include/leds.php");

if(!file_exists("/var/www/html/config/settings.dat")){
    echo date("Y-m-d H:i:s").": settings.dat file not found. Setting up from settings.ini and setting up network.\n";
    $settings = parse_ini_file("/var/www/html/config/settings.ini", true);
	file_put_contents("/var/www/html/config/settings.dat", json_encode($settings));
	exec("sudo sync");
	setup_network($settings['Network']['Ssid'],$settings['Network']['SsidPassword'],$settings['Network']['IpType'],$settings['Network']['IpAddress'],$settings['Network']['IpMask'],$settings['Network']['IpGateway'],$settings['Network']['IpDns']);
	echo date("Y-m-d H:i:s").": Default settings were applied and network reconfigured to defaults.\n";
}
$settings = json_decode(file_get_contents("/var/www/html/config/settings.dat"),TRUE);
$settingsMtime=filemtime("/var/www/html/config/settings.dat");

// initialise important settings that might not be in the settings file.
if(!isset($settings['Options']['LEDsOffTimer'])) $settings['Options']['LEDsOffTimer']="20";
if(!isset($settings['Network']['WiFiReconnect'])) $settings['Network']['WiFiReconnect']="No";

$stateFile="/var/www/html/".$settings['State']['FileName'];
if(!file_exists($stateFile)){
	$spkrData = [
			"Spkr1" => "On", "Spkr2" => "Off", "Spkr3" => "Off", "Spkr4" => "Off",
			"Spkr5" => "Off", "Spkr6" => "Off", "Spkr7" => "Off", "Spkr8" => "Off",
			"Order" => [ "0" => "Spkr1" ]
	];
	file_put_contents($stateFile, json_encode($spkrData));
	exec("sudo sync");
}
$spkrData = json_decode(file_get_contents($stateFile),TRUE);

exec( "cat /proc/device-tree/model", $output, $returned );
if(strpos(implode($output),"Raspberry")!==FALSE){
 $settings['Options']['Processor']="Raspberry Pi";
 $i2cbus="1";
 include("/var/www/html/include/netops.php");
}elseif(strpos(implode($output),"Banana")!==FALSE){
 $settings['Options']['Processor']="Banana Pi";
 $i2cbus="0";
 include("/var/www/html/include/netops2.php");
}elseif(strpos(implode($output),"Orange")!==FALSE){
 $settings['Options']['Processor']="Orange Pi";
 $i2cbus="0";
 include("/var/www/html/include/netops2.php");
} else {
 $settings['Options']['Processor']="Other";
 include("/var/www/html/include/netops2.php");
 $i2cbus="1";
}

echo date("Y-m-d H:i:s").": Setting i2c IO port pins to pull ups.\n";

// set IO port LED pins to pull ups
exec('i2cset -y '.$i2cbus.' 0x22 0x06 0xff');
exec('i2cset -y '.$i2cbus.' 0x21 0x06 0xff');
exec('i2cset -y '.$i2cbus.' 0x22 0x00 0x55');
exec('i2cset -y '.$i2cbus.' 0x21 0x00 0x55');
exec('i2cset -y '.$i2cbus.' 0x24 0x00 0x00');

if(file_exists("/var/www/html/state/restart")){
    // flash all the LEDs 2 times to indicate factory default (or software update) is completed
    echo date("Y-m-d H:i:s").": Restarting the WiFi and network.\n";
    flashLeds(2);
    setup_network($settings['Network']['Ssid'],$settings['Network']['SsidPassword'],$settings['Network']['IpType'],$settings['Network']['IpAddress'],$settings['Network']['IpMask'],$settings['Network']['IpGateway'],$settings['Network']['IpDns']);
	unlink("/var/www/html/state/restart");
}else flashLeds(5);	// flash LEDs five times to indicate power on

//$spkrData = json_decode(file_get_contents($stateFile),TRUE);
$timeout=0;
$defaults=0;
$change=1;
$firsttime=0;

$timer20=time();    // 20 second event timer (for network keep alive DFGW ping test)
$wifiKeepAlive=0;   // wifiKeepAlive is reset to the current time each time a DFGW ping is successful
$wifiHoldTimer=600; // if the time minus wifiHoldTimer > wifiKeepAlive then trigger a WiFi network restart
$lastPing=false;    // preset the ping check status to false so that we get a normalization message when enabled or ping response is restored

if(isset($settings['Network']['WiFiReconnect']) && $settings['Network']['WiFiReconnect']=="Yes") echo date("Y-m-d H:i:s").": WiFi network reconnect is enabled.\n";

echo date("Y-m-d H:i:s").": Going into main endless loop.\n";

while(!file_exists("/var/www/html/state/restart") ){

 unset($keypad);
 $command='i2cget -y '.$i2cbus.' 0x22 0x09';
 exec($command,$keypad); // get the pb switches of the low IO port
 $keys = intval($keypad[0],16);

 if(($keys&0x55)<0x55&&$firsttime==0){
  $firsttime=1;
  $change=1;
 }elseif(($keys&0x55)<0x55){
  for ($count=1;$count<5;$count++){
   if($spkrData['Spkr'.$count]=='On' && (!($keys&(1<<(($count-1)*2))))){
    $spkrData['Spkr'.$count]='Off';
    $spkrData=removeFromFIFO($count,$spkrData,$settings['Options']['MaximumActiveSpeakers']);
    $change=1;
   }else if($spkrData['Spkr'.$count]=='Off' && (!($keys&(1<<(($count-1)*2))))){
    $spkrData['Spkr'.$count]='On';
    $spkrData=insertIntoFIFO($count,$spkrData,$settings['Options']['MaximumActiveSpeakers']);
    $change=1;
   }
  }
 }

 unset($keypad);
 exec('i2cget -y '.$i2cbus.' 0x21 0x09',$keypad); // get the pb switches of the high IO port
 $keys = intval($keypad[0],16);

 // handle buttons when the factory default button is being pressed
 while(($keys&0x40)==0){
    $defaults++;
     if($defaults==1){
         $localIP = GetIpAddress();
         echo date("Y-m-d H:i:s").": Contacting http://www.katoombasound.com/tools/SpeakerSwitchPhoneHome.php?model=SPKR7&IP=".$localIP."\n";
         $command = 'sudo wget "https://www.katoombasound.com/tools/SpeakerSwitchPhoneHome.php?model=SPKR7&IP='.$localIP.'" --no-check-certificate -O /dev/null';
         exec($command);
     }
     if($defaults>325){
         for($x=1;$x<10;$x++){
             exec('i2cset -y '.$i2cbus.' 0x22 0x09 0xA8');
             exec('i2cset -y '.$i2cbus.' 0x21 0x09 0xAA');
             usleep(500000);
             exec('i2cset -y '.$i2cbus.' 0x22 0x09 0xAA');
             usleep(500000);
         }
         if(($keys&0x10)==0){ // restore previous software version if zone button 7 is depressed
             //  echo "Restoring default software from defaults.tar\n";
             echo date("Y-m-d H:i:s").": Restoring speaker switch back to factory defaults.";
             exec("sudo tar -xvf /var/www/html/defaults/defaults.tar -C /var/www/html");
             exec("sudo chown www-data:www-data /var/www/html/* -R");
             exec("sudo chmod 755 /var/www/html/* -R");
             //   echo "Restoring system complete\n";
         }else{ // if only the rear button is held then reset the device to default configuration and enable ssh prior to device restart
             echo date("Y-m-d H:i:s").": Resetting configuration to defaults\n";
             $settings = parse_ini_file("/var/www/html/config/settings.ini", true);
             file_put_contents("/var/www/html/config/settings.dat", json_encode($settings));
             exec("sudo sync");
             copy("/var/www/html/".$settings['State']['Default'], "/var/www/html/".$settings['State']['FileName']);
             setup_network("katoombasound","","static","","","","");
         }
         exec("sudo systemctl enable ssh"); // emergency ssh
         echo date("Y-m-d H:i:s").": Shutting down and restarting speaker switch unit.\n";
         flashLeds(3);	// flash LEDs three times to indicate rear switch defaults
         exec('sudo shutdown -r now'); // reboot the device
         $defaults=0;
     }
     unset($keypad);
     exec('i2cget -y '.$i2cbus.' 0x21 0x09',$keypad); // get the pb switches of the high IO port
     $keys = intval($keypad[0],16);
 }
 $defaults=0;

 if(($keys&0x55)<0x55&&$firsttime==0){
  $firsttime=1;
  $change=1;
 }elseif(($keys&0x55)<0x55){
  for ($count=5;$count<8;$count++){
   if($spkrData['Spkr'.$count]=='On' && (!($keys&(1<<(($count-5)*2))))){
    $spkrData['Spkr'.$count]='Off';
    $spkrData=removeFromFIFO($count,$spkrData,$settings['Options']['MaximumActiveSpeakers']);
    $change=1;
   }else if($spkrData['Spkr'.$count]=='Off' && (!($keys&(1<<(($count-5)*2))))){
    $spkrData['Spkr'.$count]='On';
    $spkrData=insertIntoFIFO($count,$spkrData,$settings['Options']['MaximumActiveSpeakers']);
    $change=1;
   }
  }
 }

 if($change){
  file_put_contents($stateFile, json_encode($spkrData));
  exec("sudo sync");

  $mask=0;
  for ($count=1;$count<5;$count++){
   if($spkrData['Spkr'.$count]=='Off'){
    $mask+=1<<(($count-1)*2+1);
   }
  }
  // TBD - hard coded for device 0x22 low IO
  $mask= $mask^2; // flip bit 1 for LED 1
  $command='i2cset -y '.$i2cbus.' 0x22 0x09 '.$mask;
  exec($command); // set the LEDs

  $mask=0;
  for ($count=5;$count<8;$count++){
   if($spkrData['Spkr'.$count]=='Off'){
    $mask+=1<<(($count-5)*2+1);
   }
  }
  // TBD - hard coded for device 0x21 high IO
  exec('i2cset -y '.$i2cbus.' 0x21 0x09 '.$mask); // set the LEDs

  $mask=0;
  for ($count=1;$count<8;$count++){
   if($spkrData['Spkr'.$count]=='On'){
    $mask+=1<<($count-1);
   }
  }
// echo "Mask: ".$mask."\n";

  // TBD - hard coded for device 0x24
  exec('i2cset -y '.$i2cbus.' 0x24 0x09 '.$mask); // set the speakers
  usleep(500000);
 }
 
 $spkrDataOld = $spkrData;
 $spkrData = json_decode(file_get_contents($stateFile),TRUE);

 $diff=0;
 for ($count=1;$count<8;$count++){
  if($spkrData['Spkr'.$count]!=$spkrDataOld['Spkr'.$count]){
   $diff=1;
   break;
  }
 }
 $OldLEDs = $settings['Options']['LEDsOffTimer'];
 $settings = json_decode(file_get_contents("/var/www/html/config/settings.dat"),TRUE);
 if($OldLEDs!=$settings['Options']['LEDsOffTimer']) $diff=1;

 if($change||$diff) $timeout=time()+$settings['Options']['LEDsOffTimer']+1;

 if(time()==$timeout&&$settings['Options']['LEDsOffTimer']!=0){
  exec('i2cset -y '.$i2cbus.' 0x22 0x09 0xA8');
  exec('i2cset -y '.$i2cbus.' 0x21 0x09 0xAA');
  $firsttime=0;
  echo date("Y-m-d H:i:s").": LEDs off timer expired. Turned all LEDs off.\n";
  sleep(1);
 }
 $change=0;
 if($OldLEDs!=$settings['Options']['LEDsOffTimer']) $change=1;

 if((isset($settings['Network']['WiFiReconnect']) && $settings['Network']['WiFiReconnect']=="Yes")){
  $now=time();
  if($now>$timer20+19){
   $timer20=$now;
   // ping the DFGW and reset wifiKeepAlive to zero if we get a response
   exec('ping -c1 -W1 _gateway; echo $?',$results);
   if(end($results)==0){
    $wifiKeepAlive=$now;
    if($lastPing==false){
     echo date("Y-m-d H:i:s").": WiFi keep alive check is receiving reply pings from the default gateway.\n";
     $lastPing=true;
     $localIP = GetIpAddress();
     echo date("Y-m-d H:i:s").": Contacting http://www.katoombasound.com/tools/SpeakerSwitchPhoneHome.php?model=SPKR7&IP=".$localIP."\n";
     exec('sudo wget "https://www.katoombasound.com/tools/SpeakerSwitchPhoneHome.php?model=SPKR7&IP='.$localIP.'" --no-check-certificate -O /dev/null');
    }
   }else{
    echo date("Y-m-d H:i:s").": WiFi keep alive check did not receive a reply ping from the default gateway for: [".($now-$wifiKeepAlive)."] seconds.\n";
    $lastPing=false;
   }
   // if now - wifiHoldTime > wifiKeepAlive then restart WiFi network
   if(($now-$wifiHoldTimer)>$wifiKeepAlive){
    echo date("Y-m-d H:i:s").": WiFi keep alive expired. Initiating WiFi network reconnect by restarting WiFi and Networking\n";
    setup_network($settings['Network']['Ssid'],$settings['Network']['SsidPassword'],$settings['Network']['IpType'],$settings['Network']['IpAddress'],$settings['Network']['IpMask'],$settings['Network']['IpGateway'],$settings['Network']['IpDns']);
    $wifiKeepAlive=$now;
   }
  }
 }
}
echo date("Y-m-d H:i:s").": Exiting spkrIo service.\n";
?>
